# Flows

## Contents

* [Flows](#flowtoclcont)
* [Deposits to Consensus Layer](#flowtoclcont-1)
* [Withdrawals from Consensus Layer](#flowtoclcont-2)

## Flows to CL Contract <a href="#flowtoclcont" id="flowtoclcont"></a>

### Definition

Deposits sent to the Consensus Layer (CL) Contract.

| Name                 | MetricID     | Unit         | Interval |
| -------------------- | ------------ | ------------ | -------- |
| Flows to CL Contract | FlowToCLCont | Native Units | 1 day    |

### Details

* ETH sent to the Consensus Layer (CL) smart contract (0x00000000219ab540356cBB839Cbe05303d7705Fa) over the daily interval, sourced from Coin Metrics ATLAS™ blockchain search engine.

### Release History

* Released September 2022.

### Availability for Assets

{% embed url="<https://coverage.coinmetrics.io/asset-metrics/FlowToCLCont>" %}

## Deposits to Consensus Layer <a href="#flowtoclcont" id="flowtoclcont"></a>

### Definition

Total deposits sent to the Consensus Layer (CL)

| Name                        | MetricID         | Unit         | Interval      |
| --------------------------- | ---------------- | ------------ | ------------- |
| Deposits to Consensus Layer | StkDepositTotNtv | Native Units | 1 day, 1 hour |

### Details

* ETH deposited to the consensus layer in the given time interval. This number will differ from the amount sent to the CL Contract due to the delay between the contract receiving funds and funds being deposited on the consensus layer. For details, refer to [Coin Metrics' State of the Network #244](https://coinmetrics.substack.com/p/state-of-the-network-issue-244#new_tab)

### Availability for Assets

{% embed url="<https://coverage.coinmetrics.io/asset-metrics-v2/StkDepositTotNtv>" %}

## Withdrawals from Consensus Layer <a href="#flowtoclcont" id="flowtoclcont"></a>

### Definition

Total deposits sent to the Consensus Layer (CL)

| Name                             | MetricID          | Unit         | Interval      |
| -------------------------------- | ----------------- | ------------ | ------------- |
| Withdrawals from Consensus Layer | StkWithdrawTotNtv | Native Units | 1 day, 1 hour |

### Availability for Assets

{% embed url="<https://coverage.coinmetrics.io/asset-metrics-v2/StkWithdrawTotNtv>" %}

## API Endpoints

Flows metrics can be accessed using these endpoints:

* `timeseries/asset-metrics`

and by passing in the metric ID's `FlowToCLCont` in the `metrics` parameter.

{% openapi src="/files/kc3C7O6zTLYNBA0AcsZt" path="/timeseries/asset-metrics" method="get" %}
[openapi.yaml](https://2398817338-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F-MO23j33wWGzm0NrZseN%2Fuploads%2Fgit-blob-a236d0d04b3b155748ce07a17aca8108fce9b7c2%2Fopenapi.yaml?alt=media)
{% endopenapi %}

{% tabs %}
{% tab title="Shell" %}

```shell
curl --compressed "https://api.coinmetrics.io/v4/timeseries/asset-metrics?metrics=FlowToCLCont&assets=eth&pretty=true&api_key=<your_key>"
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
response = requests.get('https://api.coinmetrics.io/v4/timeseries/asset-metrics?metrics=FlowToCLCont&assets=eth&pretty=true&api_key=<your_key>').json()
print(response)
```

{% endtab %}

{% tab title="Python Client" %}

```python
from coinmetrics.api_client import CoinMetricsClient

api_key = "<API_KEY>"
client = CoinMetricsClient(api_key)

print(
    client.get_asset_metrics(
        metrics="FlowToCLCont", 
        assets="eth",
    ).to_dataframe()
)
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://gitbook-docs.coinmetrics.io/network-data/network-data-overview/staking/flows.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
